# Code Skeleton for Lab 3 and Lab 4
This folder contains the code skeleton that you will be working on during Lab 3 and Lab 4.

## Lab 3
For Lab 3 two files are of interest, `parser.y` and `scanner.l`.

To start, begin by integrating what you did in lab 1 to the `scanner.l` file.
Here it is important that you are careful, and that you do not simply copy paste.
Look at the structure of `scanner.l` and enter your rules s.t you do not remove any includes present in that file.

Following this a good starting point for Lab 3 is to start by implementing support for the different expressions:
```C
/* --- Your code here ---
 *
 * Insert the expression grammar here
 * The start symbol of the expression grammar is
 * expression. This is important since it's used
 * in a number of other places.
 *
 * Make sure that your code creates itor nodes in the
 * AST wherever necessary and that it only created
 * trees for expressions with compatible types!
 */

expression :
        {
          cerr << "Expression here" << endl;
        }
        ;
```

Followed by the different rules for the conditions of the language:

```C
/* --- Your code here ---
 *
 * Insert the condition grammar here
 * The start symbol is condition. It's used
 * elsewhere, so make sure you get it right.
 * The boolean constants false and true are represented using the BooleanConstant AST-node.
 * The other logical relations are subclasses of BinaryRelation. 
 * See the file ast.hh for the declarations.
*/
condition :
        {
          cerr << "Condition here" << endl;
        }
        ;

/* --- End your code --- */
```

### Testing Lab 3.
There is a number of test files in the `test` directory that you may use to check if your parser works as expected.

We also provide traces that you can use to compare the output of your solution to some expected output.
To do this you can exceute the following sequence of commands.
To check if you get about the same result for expressions you can run:

```bash
./compiler ./test/expression_test.prog > my_output.txt
diff -y my_output.txt ../traces/trace_expression_test.txt
```

The same procedure can be done for the more advanced test, that is `traces/trace-lab3.txt`

```
./compiler ./test/test > my_output.txt
diff -y my_output.txt ../traces/trace-lab3.txt
```

## Lab 4

In Lab 4 you will work in file `codegen.cc` search for  `/* --- Your code here --- */`'
to see where you need to introduce your changes.

A good place to start is the function `BinaryGenerateCode`

```C++
/*
 *
 * This function is used to generate code for all kinds of binary
 * operators and relations. The arguments to the function are the
 * following:
 *
 * q        The QuadsList onto which the generated code is placed.
 * realop   The quad to generate for the operator if the arguments
 *          are of type real.
 * intop    The quad to generate for the operator if the arguments
 *          are of type integer.
 * left     The AST for the left-hand side of the operator. The
 *          value type of this AST must be the same as that of the
 *          AST for the right-hand side.
 * right    The AST for the right-hand side of the operator. The
 *          value type of this AST must be the same as that of the
 *          AST for the left-hand side.
 * node     The operator node itself. You probably won't need this
 *          unless you want to print an error message.
 * type     If not NULL, this is the type of the result. This is
 *          used for relations, where the type of the result is
 *          always integer, even if the operands are real. If this
 *          parameter is NULL, then the type of the result is the
 *          same as the type of the operands (the parser needs to
 *          make sure that the operands have the same type.)
 *
 * See the GenerateCode methods for the binary operators for
 * examples of how this function is used.
 *
 */

static VariableInformation *BinaryGenerateCode(QuadsList& q,
                                               tQuadType realop,
                                               tQuadType intop,
                                               ASTNode *left,
                                               ASTNode *right,
                                               ASTNode *node,
                                               TypeInformation *type = NULL)
{
  /* --- Your code here --- */
  return NULL;
  /* --- End your code --- */
}
```


### Testing Lab 4
In order to test Lab 4, there exists a test script.
For more details see the README in the test folder.


## Other notes
For more exhaustive documentation see [The Lab Skeleton Documentation](https://www.ida.liu.se/~TDDD55/laboratories/instructions/_static/skeleton.pdf)
