#!bin/bash
# Author: John Tinnerholm(johti17) johti17@liu.se
# This file tests if the last lab (Lab-4 generates correct code)
# Simple passing this test might not be enough to complete the laboration since there might be other issues..
# To the curious reader, yes this could have been solved by a function..

echo "****Testing Lab 4****"
echo "Testing simple expressions"
./compiler -c ./test/expression_test.prog > expression_test.c
if [ $? -eq 0 ]; then
    echo "Compilation-OK"
else
    echo "Compilation-Failed.. exiting"
    exit 1
fi

echo "Frontend OK"
echo "Translating to C-Code..."

gcc expression_test.c -o  expression_test -lm -Wno-int-conversion

if [ $? -eq 0 ]; then
    echo "C-Code-Compilation-OK"
else
    echo "C-Code-Compilation-Failed.. exiting"
    exit 1
fi

echo "Testing the expression_test"


./expression_test > expression_output

if [ $? -eq 0 ]; then
    echo "Program ran sucessfully"
else
    echo "Program-Failed.. exiting"
    exit 1
fi

echo "Checking that we get the correct output.."

if cmp -s "./expression_output" "test/expression_output_ref"; then
    echo "The program generated the correct output"
else
    echo "The output does not match..."
    diff -y expression_output ./test/expression_output_ref
    echo "Exiting.."
    exit 1
fi
echo "Removing the testfile: rm expression_output"
#Remove the testfile
rm expression_output
echo "***********************"
echo "expression_test passed!"
echo "***********************"
#= Factorial =#
echo "Testing factorial_test"
./compiler -c ./test/factorial_test.prog > factorial_test.c
if [ $? -eq 0 ]; then
    echo "Compilation-OK"
else
    echo "Compilation-Failed.. exiting"
    exit 1
fi

echo "Frontend OK"
echo "Translating to C-Code..."

gcc factorial_test.c -o  factorial_test -lm -Wno-int-conversion

if [ $? -eq 0 ]; then
    echo "C-Code-Compilation-OK"
else
    echo "C-Code-Compilation-Failed.. exiting"
    exit 1
fi

echo "Testing the factorial_test"


./factorial_test > factorial_output

if [ $? -eq 0 ]; then
    echo "Program ran sucessfully"
else
    echo "Program-Failed.. exiting"
    exit 1
fi

echo "Checking that we get the correct output.."

if cmp -s "./factorial_output" "test/factorial_output_ref"; then
    echo "The program generated the correct output"
else
    echo "The output does not match..."
    diff -y factorial_output ./test/factorial_output_ref
    echo "Exiting.."
    exit 1
fi
echo "Removing the testfile: rm factorial_output"
#Remove the testfile
rm factorial_output
echo "***********************"
echo "factorial_test passed!"
echo "***********************"
#= Fibonacci =#
echo "Testing fibonacci_test"
./compiler -c ./test/fibonacci_test.prog > fibonacci_test.c
if [ $? -eq 0 ]; then
    echo "Compilation-OK"
else
    echo "Compilation-Failed.. exiting"
    exit 1
fi

echo "Frontend OK"
echo "Translating to C-Code..."

gcc fibonacci_test.c -o  fibonacci_test -lm -Wno-int-conversion

if [ $? -eq 0 ]; then
    echo "C-Code-Compilation-OK"
else
    echo "C-Code-Compilation-Failed.. exiting"
    exit 1
fi

echo "Testing the fibonacci_test"


./fibonacci_test > fibonacci_output

if [ $? -eq 0 ]; then
    echo "Program ran sucessfully"
else
    echo "Program-Failed.. exiting"
    exit 1
fi

echo "Checking that we get the correct output.."

if cmp -s "./fibonacci_output" "test/fibonacci_output_ref"; then
    echo "The program generated the correct output"
else
    echo "The output does not match..."
    diff -y fibonacci_output ./test/fibonacci_output_ref
    echo "Exiting.."
    exit 1
fi
echo "Removing the testfile: rm fibonacci_output"
#Remove the testfile
rm fibonacci_output
echo "***********************"
echo "fibonacci_test passed!"
echo "***********************"
#= Simple array =#
echo "Testing simple_array_test"
./compiler -c ./test/simple_array_test.prog > simple_array_test.c
if [ $? -eq 0 ]; then
    echo "Compilation-OK"
else
    echo "Compilation-Failed.. exiting"
    exit 1
fi

echo "Frontend OK"
echo "Translating to C-Code..."

gcc simple_array_test.c -o  simple_array_test -lm -Wno-int-conversion

if [ $? -eq 0 ]; then
    echo "C-Code-Compilation-OK"
else
    echo "C-Code-Compilation-Failed.. exiting"
    exit 1
fi

echo "Testing the simple_array_test"


./simple_array_test > simple_array_test_output

if [ $? -eq 0 ]; then
    echo "Program ran sucessfully"
else
    echo "Program-Failed.. exiting"
    exit 1
fi

echo "Checking that we get the correct output.."

if cmp -s "./simple_array_test_output" "test/simple_array_test_output_ref"; then
    echo "The program generated the correct output"
else
    echo "The output does not match..."
    diff -y simple_array_test_output ./test/simple_array_test_output_ref
    echo "Exiting.."
    exit 1
fi
echo "Removing the testfile: rm simple_array_output"
#Remove the testfile
rm simple_array_test_output
echo "***********************"
echo "simple_array_test passed!"
echo "***********************"

#= Simple array =#
echo "Testing sort_test"
./compiler -c ./test/sort_test.prog > sort_test.c
if [ $? -eq 0 ]; then
    echo "Compilation-OK"
else
    echo "Compilation-Failed.. exiting"
    exit 1
fi

echo "Frontend OK"
echo "Translating to C-Code..."

gcc sort_test.c -o  sort_test -lm -Wno-int-conversion

if [ $? -eq 0 ]; then
    echo "C-Code-Compilation-OK"
else
    echo "C-Code-Compilation-Failed.. exiting"
    exit 1
fi

echo "Testing the sort_test"


./sort_test > sort_test_output

if [ $? -eq 0 ]; then
    echo "Program ran sucessfully"
else
    echo "Program-Failed.. exiting"
    exit 1
fi

echo "Checking that we get the correct output.."

if cmp -s "./sort_test_output" "test/sort_test_output_ref"; then
    echo "The program generated the correct output"
else
    echo "The output does not match..."
    diff -y sort_test_output ./test/sort_test_output_ref
    echo "Exiting.."
    exit 1
fi
echo "Removing the testfile: rm simple_array_output"
#Remove the testfile
rm sort_test_output
echo "***********************"
echo "sort_test passed!"
echo "***********************"
